#-----------------------------------------------------------------------------
# Timeline
# 12/24/03
# Copyright (c) 2003, David G. Drumright.  All rights reserved.
#-----------------------------------------------------------------------------
import os
import sys
from Tkinter import *
import poser
scene=poser.Scene()
if float(poser.Version()) < 5.0:
    import _TLmodule15
    ShowBMP = _TLmodule15.ShowBMP
else:
    import _TLmodule22
    ShowBMP = _TLmodule22.ShowBMP

BasePathUncut=poser.AppLocation()
BasePath=BasePathUncut[:(-len('poser.exe'))]
MyPath=os.path.normpath(BasePath+'Runtime/Python/Timeline/')

#-----------------------------------------------------------------------------
# Next section is TK
#------------------------------------------------------------

class App:
    def __init__(self, master, textMessage):
        self.master = master
        master.title("TimeLine")
        self.CenterFrame=0
        self.StartFrame=0
        self.SkipCount = float(scene.NumFrames()) / 7.0  # Starting value
        self.Notes = {} # dict to hold notes, indexed by frame

        self.StatusFrame=Frame(self.master)
        self.StatusFrame.grid(row=0,column=0)
        self.ButtonFrame=Frame(self.master)
        self.ButtonFrame.grid(row=1,column=0)
        self.PictureFrame=Frame(self.master)
        self.PictureFrame.grid(row=2,column=0)

        self.NoteChooseLabel = Label(self.StatusFrame,text="Frame number and note (hit enter):").grid(row=0,column=0)
        self.NoteChooseEntry = Entry(self.StatusFrame,width=6)
        self.NoteChooseEntry.grid(row=0,column=1)
        self.MakeNoteEntry = Entry(self.StatusFrame,width=100)
        self.MakeNoteEntry.grid(row=0,column=2)

        self.buttonMoveLeft = Button(self.ButtonFrame, text="<", command=self.HandleMoveLeft)
        self.buttonMoveLeft.grid(row=2, column=0)
        self.buttonZoomIn = Button(self.ButtonFrame, text="Zoom in", command=self.HandleZoomIn)
        self.buttonZoomIn.grid(row=2, column=2)
        self.buttonRefresh = Button(self.ButtonFrame, text="Start", command=self.HandleRefresh)
        self.buttonRefresh.grid(row=2, column=4)
        self.buttonZoomOut = Button(self.ButtonFrame, text="Zoom Out", command=self.HandleZoomOut)
        self.buttonZoomOut.grid(row=2, column=6)
        self.buttonMoveRight = Button(self.ButtonFrame, text=">", command=self.HandleMoveRight)
        self.buttonMoveRight.grid(row=2, column=8)

        self.OneLabel=[]
        self.OneFrame=[]
        self.FrameOfBox=[0,0,0,0,0,0,0]
        for i in range(7):
            L=Entry(self.PictureFrame,text=str(i+1))
            L.grid(row=0,column=i)
            self.OneLabel.append(L)
            F = Canvas(self.PictureFrame,width=100,height=100,bg="white",borderwidth=2,relief=RIDGE)
            F.grid(row=1,column=i)
            if   i==0: F.bind("<Button-1>",self.F0Action)
            elif i==1: F.bind("<Button-1>",self.F1Action)
            elif i==2: F.bind("<Button-1>",self.F2Action)
            elif i==3: F.bind("<Button-1>",self.F3Action)
            elif i==4: F.bind("<Button-1>",self.F4Action)
            elif i==5: F.bind("<Button-1>",self.F5Action)
            elif i==6: F.bind("<Button-1>",self.F6Action)
            self.OneFrame.append(F)

        self.NoteChooseEntry.bind("<Return>",self.NoteChooseAction)
        self.MakeNoteEntry.bind("<Return>",self.MakeNoteAction)

        # Exit cleanly
        self.master.protocol('WM_DELETE_WINDOW', self.HandleCancel)


    # - - - - - - - - - - - - - - - - - -
    # - - - - - - - - - - - - - - - - - -

    def Update(self):
        if scene: scene.ProcessSomeEvents(1)
        root.lift()
        root.after(250, self.Update)

    # - - - - - - - - - - - - - - - - - -
    def HandleRefresh(self):
        self.FillFrame()
    # - - - - - - - - - - - - - - - - - -
    def HandleZoomIn(self):
        self.SkipCount=self.SkipCount-1
        if self.SkipCount<1:self.SkipCount=1
        self.StartFrame = self.CenterFrame - (self.SkipCount*3) +1
        # We know how many skips from start to center, so just hardwire!
        if self.StartFrame < 0: self.StartFrame=0
        self.FillFrame()
        return
    # - - - - - - - - - - - - - - - - - -
    def HandleZoomOut(self):
        self.SkipCount=self.SkipCount+1
        if self.SkipCount>scene.NumFrames(): self.SkipCount=scene.NumFrames()
        self.StartFrame = self.CenterFrame - (self.SkipCount*3) +1
        # We know how many skips from start to center, so just hardwire!
        if self.StartFrame < 0: self.StartFrame=0
        self.FillFrame()
        return
    # - - - - - - - - - - - - - - - - - -
    def HandleMoveLeft(self):
        if self.StartFrame > 0:
            self.StartFrame = self.StartFrame-1
            self.CenterFrame = self.CenterFrame-1
            self.FillFrame()
    # - - - - - - - - - - - - - - - - - -
    def HandleMoveRight(self):
        if self.StartFrame < scene.NumFrames()-1:
            self.StartFrame = self.StartFrame+1
            self.CenterFrame = self.CenterFrame+1
            self.FillFrame()
    # - - - - - - - - - - - - - - - - - -
    # - - - - - - - - - - - - - - - - - -
    def NoteChooseAction(self,event):
        # Force CenterFrame to this value
        NCEstring=self.NoteChooseEntry.get()
        if NCEstring:
            self.CenterFrame=int(NCEstring)-1
            self.StartFrame = self.CenterFrame - (self.SkipCount*3) +1
            self.MakeNoteEntry.delete(0,END) # Get rid of whatever shows
            # Show existing notes for this frame if any.
            try: # If nothing there, just insert a blank.
                Existing = ' ' + self.Notes[int(NCEstring)]
            except:
                Existing = ''
            self.MakeNoteEntry.insert(END,Existing)
            self.FillFrame()

    # - - - - - - - - - - - - - - - - - -
    def MakeNoteAction(self,event):
        # Use Centerframe as index, put this note in the dict.
        # The string will include whatever was already under this
        # index, as shown during NoteChooseAction.  You can add or
        # delete to that string manually; we don't force append.
        NCEstring=self.NoteChooseEntry.get()
        if NCEstring:  Num = int(NCEstring) # Get the number entry
        self.NoteChooseEntry.delete(0,END) # Clear the number entry
        MNAstring=self.MakeNoteEntry.get() # Get what you wrote
        if MNAstring:
            self.Notes[Num]=MNAstring
    # - - - - - - - - - - - - - - - - - -
    def F0Action(self,event):  # When click in frame 0, set the center for the zoom actions
        self.CenterFrame=self.FrameOfBox[0]
    # - - - - - - - - - - - - - - - - - -
    def F1Action(self,event):  # When click in frame 1, set the center for the zoom actions
        self.CenterFrame=self.FrameOfBox[1]
    # - - - - - - - - - - - - - - - - - -
    def F2Action(self,event):  # When click in frame 2, set the center for the zoom actions
        self.CenterFrame=self.FrameOfBox[2]
    # - - - - - - - - - - - - - - - - - -
    def F3Action(self,event):  # When click in frame 3, set the center for the zoom actions
        self.CenterFrame=self.FrameOfBox[3]
    # - - - - - - - - - - - - - - - - - -
    def F4Action(self,event):  # When click in frame 4, set the center for the zoom actions
        self.CenterFrame=self.FrameOfBox[4]
    # - - - - - - - - - - - - - - - - - -
    def F5Action(self,event):  # When click in frame 5, set the center for the zoom actions
        self.CenterFrame=self.FrameOfBox[5]
    # - - - - - - - - - - - - - - - - - -
    def F6Action(self,event):  # When click in frame 6, set the center for the zoom actions
        self.CenterFrame=self.FrameOfBox[6]
    # - - - - - - - - - - - - - - - - - -

    def FillFrame(self):
        # Hold onto actual frame, and be sure we have fast render. (Change
        # the AA and Bump, which are slowdowns; leave the other qualities.)
        HoldFrame = scene.Frame()
        if self.StartFrame < 0: self.StartFrame = 0
        SecProp = 1.0 / scene.FramesPerSecond()
        for i in range(7):
            # Set frame, render
            f = int(float(i) * self.SkipCount) + self.StartFrame
            if (f+1) >= scene.NumFrames(): f = scene.NumFrames()-1
            scene.SetFrame(f)
            scene.DrawAll()
            # Make name and save image
            TryName = os.path.abspath('%s/%d.BMP' % (MyPath,i))
            scene.SaveImage("bmp",TryName)
            # Find hwnd of this box, do the Show action
            Hwnd = self.OneFrame[i].winfo_id()
            retval = ShowBMP(Hwnd, TryName,4,4,100,100)
            if retval < 1: raise "Render error %d" % retval
            # Fill in the label and the frame-of-box holder
            self.FrameOfBox[i]=f
            Sec = f * SecProp
            self.OneLabel[i].delete(0,END)
            self.OneLabel[i].insert(0,"frame %d at %.1f sec" %(f+1,Sec))

        # Restore actual frame
        scene.SetFrame(HoldFrame)
        # Set center frame to the middle box
        self.CenterFrame=self.FrameOfBox[3]

    # - - - - - - - - - - - - - - - - - -

    def HandleCancel(self):
        # Pour out the notes to a file and to the clipboard.
        if len(self.Notes.keys()):
            self.MakeNoteEntry.clipboard_clear()
            FileName=os.path.abspath('%s/timenotes.txt' % MyPath)
            fpTemp=open(FileName,"wt")
            for F in range(scene.NumFrames()):  # To get them in proper order
                if F in self.Notes.keys():
                    St = "%d: %s\n" % (F,self.Notes[F])
                    self.MakeNoteEntry.clipboard_append(St)
                    fpTemp.write(St)
            fpTemp.close()

        self.master.destroy()

#------------------------------------------------------------
# Activate the loop
#------------------------------------------------------------

root = Tk()
app = App(root, '')
app.Update()  # degug sharing
root.mainloop()

#------------------------------------------------------------
# End TK loop.
#-----------------------------------------------------------------------------
